JsonDeserializer (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.map

## Class JsonDeserializer<T>

- java.lang.Object
- - org.codehaus.jackson.map.JsonDeserializer<T>

- Direct Known Subclasses:
    AbstractDeserializer, JsonDeserializer.None, StdDeserializer, StdDeserializerProvider.WrappedDeserializer

      public abstract class JsonDeserializer<T>
      extends Object

  Abstract class that defines API used by `ObjectMapper` (and other chained `JsonDeserializer`s too) to deserialize Objects of arbitrary types from JSON, using provided `JsonParser`.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `JsonDeserializer.None` This marker class is only to be used with annotations, to indicate that no deserializer is configured.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JsonDeserializer()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract T` | `deserialize(JsonParser jp, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `T` | `deserialize(JsonParser jp, DeserializationContext ctxt, T intoValue)` Alternate deserialization method (compared to the most commonly used, `deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer.
    `Object` | `deserializeWithType(JsonParser jp, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Deserialization called when type being deserialized is defined to contain additional type identifier, to allow for correctly instantiating correct subtype.
    `T` | `getEmptyValue()` Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings).
    `T` | `getNullValue()` Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`).
    `JsonDeserializer<T>` | `unwrappingDeserializer()` Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### JsonDeserializer

          public JsonDeserializer()

  - ### Method Detail

    - #### deserialize

          public abstract T deserialize(JsonParser jp,
                      DeserializationContext ctxt)
                                 throws IOException,
                                        JsonProcessingException

      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker. Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Parameters:
        `jp` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserializer value
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### deserialize

          public T deserialize(JsonParser jp,
                      DeserializationContext ctxt,
                      T intoValue)
                        throws IOException,
                               JsonProcessingException

      Alternate deserialization method (compared to the most commonly used, `deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer. Method is not necessarily used for all supported types; most commonly it is used for Collections and Maps.

      Default implementation just throws `UnsupportedOperationException`, to indicate that types that do not explicitly add support do not expect to get the call.

      Throws:
        `IOException`
        `JsonProcessingException`

    - #### deserializeWithType

          public Object deserializeWithType(JsonParser jp,
                                   DeserializationContext ctxt,
                                   TypeDeserializer typeDeserializer)
                                     throws IOException,
                                            JsonProcessingException

      Deserialization called when type being deserialized is defined to contain additional type identifier, to allow for correctly instantiating correct subtype. This can be due to annotation on type (or its supertype), or due to global settings without annotations.

      Default implementation may work for some types, but ideally subclasses should not rely on current default implementation. Implementation is mostly provided to avoid compilation errors with older code.

      Parameters:
        `typeDeserializer` - Deserializer to use for handling type information
      Throws:
        `IOException`
        `JsonProcessingException`
      Since:
        1.5

    - #### unwrappingDeserializer

          public JsonDeserializer<T> unwrappingDeserializer()

      Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.

      Default implementation just returns 'this' indicating that no unwrapped variant exists

      Since:
        1.9

    - #### getNullValue

          public T getNullValue()

      Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`). Usually this is simply Java null, but for some types (especially primitives) it may be necessary to use non-null values.

      Note that deserializers are allowed to call this just once and then reuse returned value; that is, method is not guaranteed to be called once for each conversion.

      Default implementation simply returns null.

    - #### getEmptyValue

          public T getEmptyValue()

      Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings). Usually this is same as `getNullValue()` (which in turn is usually simply Java null), but it can be overridden for types. Or, if type should never be converted from empty String, method can also throw an exception.

      Default implementation simple calls `getNullValue()` and returns value.

      Since:
        1.9